//  Download
//
//  last rev. 29/12/1999    11:09

import java.lang.*;
import java.util.*;

abstract public class Download extends java.lang.Object
{
    protected String	location;
    protected String	target;
    protected Hashtable	options;
	
	protected boolean	resume;     //  This indicates that the download should resume, 
	                                //  if the server doesn't agree, the start method 
	                                //  should throw an exception which will abort the 
	                                //  download without modifying in any way the local file.

                                    //  The action taken depends on the presence and the
                                    //  value of the user option RESUME.

    ///////////////////////////////////////////////////////////////////////////////
    
    public Download() {
		//	Le istanze di questa classe non sono direttamente utilizzabili
		//	per creare gli oggetti di una sottoclasse bisogna usare il metodo
		//	statico create() che ritorna un oggetto di classe download
    
		//{{INIT_CONTROLS
		//}}
	}
 
    ///////////////////////////////////////////////////////////////////////////////
    
    static public Download create( String location, String target, Hashtable options )
    {
        String  download_mode = (String)options.get("DOWNLOAD_MODE");
                download_mode = download_mode != null ? download_mode : "SIMPLE";
        
        if( download_mode.equals("ADVANCED") )
        try {
	        return new AdvancedDownload( location, target, options );
        } catch( DownloadException e ) {
        	//  TODO:   could not create an advanced download...maybe better try a simple one ?
        	return null;
        }
	    else 
	    try {
	        return new SimpleDownload( location, target, options );
		} catch( DownloadException e ) {
        	//  TODO:   could not create a simple download...perhaps user is not connected or something else...
        	return null;
        }
        
        
	}
    
    abstract public void start() throws DownloadException;

    abstract public void stop() throws DownloadException;

	//{{DECLARE_CONTROLS
	//}}
}