import java.lang.*;

public class LocationParser extends java.lang.Object
{
    String  location;
    
    public LocationParser( String location ) 
    {
        this.location = location;
	
		//{{INIT_CONTROLS
		//}}
	}

    public String protocol()
    throws LocationParserException
    {
        int begin = 0;
        int end   = location.indexOf( "://" );
        
        if( end != -1 )
            return location.substring( begin, end );
        else
            throw new LocationParserException( "Unable to determine protocol" );
    }
   
    public String username() 
    throws LocationParserException
    {
        int begin = location.indexOf( "://" ) + 3;
        int end   = location.indexOf( "@", begin );
        
        if( end != -1 )
            return location.substring( begin, location.indexOf( ":", begin ) );
        else
            return null;
    }
   
    public String password() 
    throws LocationParserException
    {
        int begin = location.indexOf( "://" ) + 3;
        int end   = location.indexOf( "@", begin );
        
        if( end != -1 )
            return location.substring( location.indexOf( ":", begin ) + 1, end );
        else
            return null;
    }
   
    public String host() 
    throws LocationParserException
    {
        int begin = location.indexOf( "://" ) + 3;
        
            if( location.indexOf( "@", begin ) != -1 ) 
                begin = location.indexOf( "@" ) + 1;
            
        int end = location.indexOf( ":", begin );
        
            if( end == -1 ) 
                end = location.indexOf( "/", begin );
        
        if( end != -1 )
            return location.substring( begin, end );
        else
            throw new LocationParserException( "Unable to determine host" );
    }
   
    public int port() 
    throws LocationParserException
    {
        int begin = location.indexOf( "://" ) + 3;
        
            if( location.indexOf( "@", begin ) != -1 ) 
                begin = location.indexOf( "@" ) + 1;
            
            begin = location.indexOf( ":", begin );
        
        int end = location.indexOf( "/", begin );
        
        if( begin != -1 && end > begin + 1 ) 
        try {
            return Integer.parseInt( location.substring( begin + 1, end ), 10 );
        }
        catch( NumberFormatException e ) {
            throw new LocationParserException( "Port syntax error" );
        }
        else {
            return 21;
        }
    }
   
    public String path()
    throws LocationParserException
    {
        int begin = location.indexOf( "://" ) + 3;
        
            begin = location.indexOf( "/", begin );
        
        if( begin != -1 )
            return location.substring( begin );
        else
            return "/";
     }

		//{{DECLARE_CONTROLS
		//}}
}