/*
	A basic extension of the java.awt.Dialog class
 */

import java.awt.*;
import java.lang.*;
import java.util.*;

public class ResumeDialog extends Dialog
{
	public ResumeDialog(Frame parent, boolean modal, Hashtable hashtable)
	{
		super(parent, modal);

		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(264,120);
		label_1 = new java.awt.Label("The file already exists and is not empty...");
		label_1.setBounds(12,24,240,24);
		add(label_1);
		label_2 = new java.awt.Label("Do you want to resume tansfer ?");
		label_2.setBounds(36,48,180,24);
		add(label_2);
		buttonYes = new java.awt.Button();
		buttonYes.setLabel("Yes");
		buttonYes.setBounds(12,84,48,24);
		buttonYes.setForeground(new Color(255));
		buttonYes.setBackground(new Color(12632256));
		add(buttonYes);
		buttonNo = new java.awt.Button();
		buttonNo.setLabel("No");
		buttonNo.setBounds(96,84,48,24);
		buttonNo.setForeground(new Color(16711680));
		buttonNo.setBackground(new Color(12632256));
		add(buttonNo);
		buttonCancel = new java.awt.Button();
		buttonCancel.setLabel("Cancel");
		buttonCancel.setBounds(180,84,72,24);
		buttonCancel.setBackground(new Color(12632256));
		add(buttonCancel);
		setTitle("Warning!");
		//}}

        this.hashtable = hashtable;

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		buttonYes.addMouseListener(aSymMouse);
		buttonNo.addMouseListener(aSymMouse);
		buttonCancel.addMouseListener(aSymMouse);
		//}}
	}
	
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;


	public ResumeDialog(Frame parent, String title, boolean modal, Hashtable hashtable)
	{
		this(parent, modal, hashtable);
		setTitle(title);
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			Rectangle bounds = getParent().getBounds();
			Rectangle abounds = getBounds();
	
			setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);
		}
		super.setVisible(b);
	}

	//{{DECLARE_CONTROLS
	java.awt.Label label_1;
	java.awt.Label label_2;
	java.awt.Button buttonYes;
	java.awt.Button buttonNo;
	java.awt.Button buttonCancel;
	//}}
	
	Hashtable   hashtable;		//	Reference to the application hashtable used 
								//	to pass options to newly created downloads

    class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == ResumeDialog.this)
				Dialog1_WindowClosing(event);
		}
	}
	
	void Dialog1_WindowClosing(java.awt.event.WindowEvent event)
	{
        dispose();
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == buttonYes)
				buttonYes_MouseClicked(event);
			else if (object == buttonNo)
				buttonNo_MouseClicked(event);
			else if (object == buttonCancel)
				buttonCancel_MouseClicked(event);
		}
	}

	void buttonYes_MouseClicked(java.awt.event.MouseEvent event)
	{
        hashtable.put( "RESUME", new Boolean(true) );
        dispose();
	}
	
	void buttonNo_MouseClicked(java.awt.event.MouseEvent event)
	{
        hashtable.put( "RESUME", new Boolean(false) );
        dispose();
	}

	void buttonCancel_MouseClicked(java.awt.event.MouseEvent event)
	{
        dispose();
	}

}
